// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Warp.h"

#include "MainFrm.h"
#include "WarpDoc.h"
#include "SrcView.h"
#include "DstView.h"
#include "OptionDlg.h"
#include "global.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_WARP_WARPING, OnWarpWarping)
	ON_COMMAND(ID_WARP_HIDEMESH, OnWarpHidemesh)
	ON_COMMAND(ID_WARP_SHOWMESH, OnWarpShowmesh)
	ON_UPDATE_COMMAND_UI(ID_WARP_WARPING, OnUpdateWarpWarping)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE, OnUpdateFileSave)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE_AS, OnUpdateFileSaveAs)
	ON_UPDATE_COMMAND_UI(ID_FILE_NEW, OnUpdateFileNew)
	ON_UPDATE_COMMAND_UI(ID_FILE_OPEN_CPT, OnUpdateFileOpenCpt)
	ON_COMMAND(ID_VIEW_OPTION, OnViewOption)
	ON_UPDATE_COMMAND_UI(ID_VIEW_OPTION, OnUpdateViewOption)
	ON_COMMAND(ID_FILE_OPEN_CPT, OnFileOpenCpt)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	m_fDataLoaded = TRUE;
	m_pdlgOption = NULL;
	m_cxMesh = GRID_SIZE;
	m_cyMesh = GRID_SIZE;
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class

	if (m_wndSplitter.CreateStatic(this,1,2))
	{
		CRect rect;
		CSize size;

		GetClientRect(&rect);
		size.cx = (rect.right - rect.left ) / 2;
		size.cy = rect.bottom;
		if (m_wndSplitter.CreateView(0,0,RUNTIME_CLASS(CSrcView),size,pContext))
		{
			if (m_wndSplitter.CreateView(0,1,RUNTIME_CLASS(CDstView),size,pContext))
			{
				SetActiveView((CView*)m_wndSplitter.GetPane(0,0));
				return TRUE;
			}
		}
	}
	return FALSE;
}

void CMainFrame::OnWarpWarping() 
{
	// TODO: Add your command handler code here
	BOOL MeshWarp(TPixmap *pSrcPixmap, TMesh *pSrcMesh, TPixmap *pDstPixmap, TMesh *pDstMesh);

	CSrcView*	pviewSrc;
	CDstView*	pviewDst;

	pviewSrc = (CSrcView*)m_wndSplitter.GetPane( 0, 0 );
	pviewDst = (CDstView*)m_wndSplitter.GetPane( 0, 1 );

	MeshWarp( &pviewSrc->m_pixmap, &pviewSrc->m_mesh,
			  &pviewDst->m_pixmap, &pviewDst->m_mesh);
	pviewSrc->Invalidate( TRUE );
	pviewDst->Invalidate( TRUE );
}
void CMainFrame::OnFileOpenCpt() 
{
	// TODO: Add your command handler code here
	static	char	szFilter[] = "Control point Files (*.src)\0*.src\0All Files(*.*)\0*.*\0\0";

	CString			file;
	char			src[128];
	char			dst[128];
	char			*p;
	CFileDialog		dlg( TRUE, "src", "*.src", OFN_HIDEREADONLY, szFilter, this );

	if( dlg.DoModal() == IDCANCEL )
		return;

	m_fDataLoaded = TRUE;

	file = dlg.GetPathName();
	lstrcpy( src, file );
	p = strchr( src, '.' );
	*p = '\0';
	lstrcpy( dst, src );

	lstrcat( src, ".src" );
	lstrcat( dst, ".dst" );

	CSrcView*	pviewSrc = (CSrcView*)m_wndSplitter.GetPane( 0, 0 );
	CDstView*	pviewDst = (CDstView*)m_wndSplitter.GetPane( 0, 1 );

	pviewSrc->m_mesh.Load( src, pviewSrc->m_pixmap.GetWidth(), pviewSrc->m_pixmap.GetHeight(), 0, 0 );
	pviewSrc->Invalidate();
	pviewDst->m_mesh.Load( dst, pviewDst->m_pixmap.GetWidth(), pviewDst->m_pixmap.GetHeight(), 0, 0 );
	pviewDst->Invalidate();

	CMenu*	pMenu = GetMenu();
	pMenu->EnableMenuItem( ID_WARP_WARPING, MF_BYCOMMAND | MF_ENABLED );
	pMenu->EnableMenuItem( ID_WARP_HIDEMESH, MF_BYCOMMAND | MF_ENABLED );
	pMenu->EnableMenuItem( ID_WARP_SHOWMESH, MF_BYCOMMAND | MF_ENABLED );
	PostMessage( WM_COMMAND, ID_WARP_SHOWMESH, 0L );
}

void CMainFrame::OnWarpHidemesh()
{
	// TODO: Add your command handler code here
	CMenu*	pMenu = GetMenu();
	if( !m_fDataLoaded )
		return;

	pMenu->CheckMenuItem( ID_WARP_HIDEMESH, MF_BYCOMMAND | MF_CHECKED );
	pMenu->CheckMenuItem( ID_WARP_SHOWMESH, MF_BYCOMMAND | MF_UNCHECKED );

	CSrcView*	pviewSrc = (CSrcView*)m_wndSplitter.GetPane( 0, 0 );
	CDstView*	pviewDst = (CDstView*)m_wndSplitter.GetPane( 0, 1 );

	pviewSrc->m_bShowMesh = FALSE;	pviewSrc->Invalidate();
	pviewDst->m_bShowMesh = FALSE;	pviewDst->Invalidate();
}

void CMainFrame::OnWarpShowmesh()
{
	// TODO: Add your command handler code here
	CMenu*	pMenu = GetMenu();

	if( !m_fDataLoaded )
		return;

	pMenu->CheckMenuItem( ID_WARP_SHOWMESH, MF_BYCOMMAND | MF_CHECKED );
	pMenu->CheckMenuItem( ID_WARP_HIDEMESH, MF_BYCOMMAND | MF_UNCHECKED );

	CSrcView*	pviewSrc = (CSrcView*)m_wndSplitter.GetPane( 0, 0 );
	CDstView*	pviewDst = (CDstView*)m_wndSplitter.GetPane( 0, 1 );

	pviewSrc->m_bShowMesh = TRUE;	pviewSrc->Invalidate();
	pviewDst->m_bShowMesh = TRUE;	pviewDst->Invalidate();
}

void CMainFrame::OnUpdateWarpWarping(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if( !m_fDataLoaded )
		pCmdUI->Enable( FALSE );
}

void CMainFrame::OnUpdateFileSave(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if( !m_fDataLoaded )
		pCmdUI->Enable( FALSE );
}

void CMainFrame::OnUpdateFileSaveAs(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable( FALSE );
}

void CMainFrame::OnUpdateFileNew(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
//	if( !m_fDataLoaded )
	pCmdUI->Enable( FALSE );
}

void CMainFrame::OnUpdateFileOpenCpt(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if( !m_fDataLoaded )
		pCmdUI->Enable( FALSE );
}

void CMainFrame::OnViewOption() 
{
	// TODO: Add your command handler code here
	if( m_pdlgOption )
		return;

	m_pdlgOption = new COptionDlg;
	m_pdlgOption->Create( IDD_DIALOG_OPTION );
	m_pdlgOption->ShowWindow( SW_SHOW );
}

void CMainFrame::OnUpdateViewOption(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if( m_pdlgOption )
	{
		pCmdUI->Enable( FALSE );
	}
	else
	{
		pCmdUI->Enable( TRUE );
	}
}

