// SrcView.cpp : implementation of the CSrcView class
//

#include "stdafx.h"
#include "Warp.h"

#include "MainFrm.h"
#include "WarpDoc.h"
#include "SrcView.h"
#include "global.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSrcView

IMPLEMENT_DYNCREATE(CSrcView, CView)

BEGIN_MESSAGE_MAP(CSrcView, CView)
	//{{AFX_MSG_MAP(CSrcView)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSrcView construction/destruction

CSrcView::CSrcView()
{
	// TODO: add construction code here
	m_bDrag = FALSE;
	m_nDragMeshX = -1;
	m_nDragMeshY = -1;
	m_bShowMesh = FALSE;
}

CSrcView::~CSrcView()
{
}

BOOL CSrcView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CSrcView drawing

void CSrcView::OnDraw(CDC* pDC)
{
	CWarpDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
	m_pixmap.Draw( pDC->GetSafeHdc(), 0, 0 );
	if( m_bShowMesh )
		m_mesh.Draw( pDC->GetSafeHdc(), 0, 0 );
}

/////////////////////////////////////////////////////////////////////////////
// CSrcView printing

BOOL CSrcView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CSrcView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CSrcView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CSrcView diagnostics

#ifdef _DEBUG
void CSrcView::AssertValid() const
{
	CView::AssertValid();
}

void CSrcView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CWarpDoc* CSrcView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CWarpDoc)));
	return (CWarpDoc*)m_pDocument;
}
#endif //_DEBUG

void CSrcView::CreateMesh( int cx, int cy )
{
	m_mesh.Create( m_pixmap.GetWidth(), m_pixmap.GetHeight(), cx, cy );
	m_bShowMesh = TRUE;
}

void CSrcView::Load( LPCTSTR file, int cxMesh, int cyMesh )
{
	m_pixmap.CreateFromBMP( file );
	CreateMesh( cxMesh, cyMesh );
}

/////////////////////////////////////////////////////////////////////////////
// CSrcView message handlers

void CSrcView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();

	CMainFrame *pwnd = (CMainFrame *)AfxGetMainWnd();
	Load( "FACE360.BMP", pwnd->m_cxMesh, pwnd->m_cyMesh );
	Invalidate();

	CMenu*	pMenu = pwnd->GetMenu();
	pMenu->EnableMenuItem( ID_WARP_WARPING, MF_BYCOMMAND | MF_ENABLED );
	pMenu->EnableMenuItem( ID_WARP_HIDEMESH, MF_BYCOMMAND | MF_ENABLED );
	pMenu->EnableMenuItem( ID_WARP_SHOWMESH, MF_BYCOMMAND | MF_ENABLED );
	pwnd->PostMessage( WM_COMMAND, ID_WARP_SHOWMESH, 0L );

//	m_mesh.Create( 320, 240, 8, 8 );
//	m_pixmap.CreateFromBMP( (LPCTSTR)FNAME_DEFAULT_BMP );
}

void CSrcView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	POINT meshPoint;

	if( m_bShowMesh )
	{
		if(m_mesh.HitTest(point.x, point.y, &meshPoint))
		{
			m_bDrag = TRUE;
			m_nDragMeshX = meshPoint.x;
			m_nDragMeshY = meshPoint.y;
			Invalidate( FALSE );

			SetCapture();
		}
	}

	CView::OnLButtonDown(nFlags, point);
}

void CSrcView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if( m_bShowMesh )
	{
		m_bDrag = FALSE;

		ReleaseCapture();
	}	
	CView::OnLButtonUp(nFlags, point);
}

void CSrcView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if( m_bShowMesh )
	{
		if(m_bDrag)
		{
			m_mesh.SetMeshPoint(m_nDragMeshX, m_nDragMeshY, point.x, point.y);
			Invalidate(FALSE);
		}
	}
	
	CView::OnMouseMove(nFlags, point);
}
