// SrcView.h : interface of the CSrcView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_SRCVIEW_H__14E5E704_A998_11D2_A5D8_ACD395F4D76B__INCLUDED_)
#define AFX_SRCVIEW_H__14E5E704_A998_11D2_A5D8_ACD395F4D76B__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "TMesh.h"
#include "TPixmap.h"
#include "WarpDoc.h"

class CSrcView : public CView
{
protected: // create from serialization only
	CSrcView();
	DECLARE_DYNCREATE(CSrcView)

// Attributes
public:
	CWarpDoc*	GetDocument();
	TMesh		m_mesh;
	TPixmap		m_pixmap;

	BOOL		m_bDrag;
	int			m_nDragMeshX;
	int			m_nDragMeshY;

	BOOL		m_bShowMesh;

// Operations
public:
	void		CreateMesh( int cx, int cy );
	void		Load( LPCTSTR file, int cxMesh, int cyMesh );

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CSrcView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CSrcView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CSrcView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in SrcView.cpp
inline CWarpDoc* CSrcView::GetDocument()
   { return (CWarpDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_SRCVIEW_H__14E5E704_A998_11D2_A5D8_ACD395F4D76B__INCLUDED_)
