#ifndef _TPIXMAP_H_
#define _TPIXMAP_H_

#include <windows.h>

// NGF : Newtype Graphic File
typedef struct tagNGF
{
	BYTE	abyID[4];
	DWORD	dwWidth;
	DWORD	dwHeight;
} NGF, *PNGF, *LPNGF;

class TPixmap
{
protected:
	LPNGF	m_lpNGF;

public:
	TPixmap();
	~TPixmap();

	LPBYTE	GetData();
	BOOL	Create( DWORD dwWidth, DWORD dwHeight );
	BOOL	CreateFromDIB( LPBITMAPINFOHEADER lpbi );
	BOOL	CreateFromBMP( LPCTSTR lpszFile );		// RGB true color BMP only
	void	Clear();
	void	Destroy();

	// get information
	int		GetWidth();                             // get width of NGF
	int		GetHeight();                            // get height of NGF
	int		GetWidthBytes();                        // get bytes per line
	int		GetHeightBytes();

	void	GetHorzScanLine(LPBYTE lpScanBuff, int nScanLine);
	void	SetHorzScanLine(LPBYTE lpScanBuff, int nScanLine);

	void	SetVertScanLine(LPBYTE lpScanBuff, int nColum);
	void	GetVertScanLine(LPBYTE lpScanBuff, int nColum);
	HBITMAP ClipRectToBitmap( HDC hdc, LPRECT lpRect );
	void	Draw(HANDLE hdc, int x, int y);
	void	Draw(HANDLE hdc, LPRECT lpRectDC = NULL, LPRECT lpRectNGF = NULL);
};

//////////////////////////////////////////////////////////////////////////////////
// inlines

#endif // _TPIXMAP_H_

